# ImageMetadata

[![][action-img]][action-url]
[![][pkgeval-img]][pkgeval-url]
[![][codecov-img]][codecov-url]

ImageMetadata is a simple package providing utilities for working with
images that have metadata attached. For example, you might want to
associate an image with the date on which the picture was taken, or an
MRI scan with patient data, or an astronomical image with sky
coordinates and information about the detector used to acquire the
image.

Read the documentation here:

[![](https://img.shields.io/badge/docs-latest-blue.svg)](https://juliaimages.org/latest/pkgs/metadata/)

<!-- URLS -->

[pkgeval-img]: https://juliaci.github.io/NanosoldierReports/pkgeval_badges/I/ImageMetadata.svg
[pkgeval-url]: https://juliaci.github.io/NanosoldierReports/pkgeval_badges/report.html
[action-img]: https://github.com/JuliaImages/ImageMetadata.jl/workflows/Unit%20test/badge.svg
[action-url]: https://github.com/JuliaImages/ImageMetadata.jl/actions
[codecov-img]: http://codecov.io/github/JuliaImages/ImageMetadata.jl/coverage.svg?branch=master
[codecov-url]: http://codecov.io/github/JuliaImages/ImageMetadata.jl?branch=master

# have to import this or @deprecate doesn't work
import Base: getindex, setindex!, delete!, haskey, get, copy!, getproperty, setproperty!

@deprecate(ImageMeta(data::AbstractArray{T,N}, props::AbstractDict{String,Any}) where {T,N},
           ImageMeta(data, to_dict(props)))

@deprecate(ImageMeta(data::AbstractArray{T,N}, props::Dict{String,Any}) where {T,N},
           ImageMeta(data, to_dict(props)))

@deprecate(ImageMeta(data::AbstractArray, props::Dict{<:AbstractString}),
           ImageMeta(data, to_dict(props)))

@deprecate(copy!(imgdest::ImageMeta, imgsrc::ImageMeta, prop1::AbstractString, props::AbstractString...),
           copy!(imgdest, imgsrc, Symbol(prop1), Symbol.(props)...))

@deprecate(delete!(img::ImageMeta, propname::AbstractString),
           delete!(img, Symbol(propname)))

@deprecate(haskey(img::ImageMeta, k::AbstractString),
           hasproperty(img, Symbol(k)))

@deprecate(hasproperty(img::ImageMeta, k::AbstractString),
           hasproperty(img, Symbol(k)))

@deprecate(get(img::ImageMeta, k::AbstractString, default),
           get(img, Symbol(k), default))

@deprecate(getindex(img::ImageMeta, propname::AbstractString),
           getproperty(img, Symbol(propname)))

@deprecate(getproperty(img::ImageMeta, propname::AbstractString),
           getproperty(img, Symbol(propname)))

@deprecate(setproperty!(img::ImageMeta, propname::AbstractString, val),
           setproperty!(img::ImageMeta, Symbol(propname), val))

@deprecate(setindex!(img::ImageMeta, X, propname::AbstractString),
           setproperty!(img, Symbol(propname), X))

@deprecate(data(img::ImageMeta), arraydata(img))

function to_dict(dold::AbstractDict{String})
    dnew = Dict{Symbol,Any}()
    for (k, v) in dold
        dnew[Symbol(k)] = v
    end
    return dnew
end

using ImageMetadata, ImageCore, Test

@testset "operations" begin
    function checkmeta(A, B)
        @test isa(A, ImageMeta)
        @test A == B
        if isa(B, ImageMeta)
            @test properties(A) == properties(B)
        end
        nothing
    end
    for A in (rand(Bool, 3, 5), rand(3, 5),
              rand(Gray{N0f8}, 3, 5), rand(RGB{N0f8}, 3, 5))
        M = ImageMeta(A)
        M2 = similar(M)
        checkmeta(-M, -A)
        checkmeta(M .+ zero(eltype(M)), M)
        checkmeta(zero(eltype(M)) .+ M, M)
        checkmeta(M .- zero(eltype(M)), M)
        checkmeta(zero(eltype(M)) .- M, -M)
        B = falses(size(M))
        if !(eltype(A) <: RGB)
            checkmeta(M + B, M)
            checkmeta(M .+ B, M)
            checkmeta((B .+ M .+ B), M)
            checkmeta(B + M, M)
            checkmeta(B .+ M, M)
            @test_throws ErrorException M + M2
            @test_throws ErrorException M .+ M2
            checkmeta(A + M, A+A)
            checkmeta(A .+ M, A+A)
            checkmeta(M + A, A+A)
            checkmeta(M .+ A, A+A)
            checkmeta(M - B, M)
            checkmeta(M .- B, M)
            checkmeta(B - M, -M)
            checkmeta(B .- M, -M)
            @test_throws ErrorException M - M2
            @test_throws ErrorException M .- M2
            checkmeta(A - M, 0*M)
            checkmeta(A .- M, 0*M)
            checkmeta(M - A, 0*M)
            checkmeta(M .- A, 0*M)
            checkmeta(A .- M .+ A, M)
            checkmeta(M .- A .+ M, M)
        end
        checkmeta(M*2, 2*M)
        checkmeta(2 .* M, 2*M)
        checkmeta(M .* 2, 2*M)
        checkmeta(M/2, M/2)
        checkmeta(M./2, M/2)
        checkmeta(M.*B, 0*M)
        checkmeta(B.*M, 0*M)
        if !(eltype(A) <: RGB)
            @test_throws ErrorException M.*M2
            checkmeta(A.*M, A.*A)
            checkmeta(M.*A, A.*A)
            checkmeta(M.^1, M)
        end
        B1 = trues(size(M))
        checkmeta(M./B1, M)
        @test_throws Union{MethodError,ErrorException} M./M2
        if !(eltype(A) <: RGB)
            checkmeta(M .+ false, M)
            checkmeta(false .+ M, M)
            checkmeta(M .+ 0.0, M)
            checkmeta(0.0 .+ M, M)
            if eltype(A) == Float64
                checkmeta(M./A, ones(size(M)))
            end
            @test (M .< 0.5) == (A .< 0.5)
            @test (M .> 0.5) == (A .> 0.5)
            @test (M .< A) == B
            @test (M .> A) == B
            @test (M .== 0.5) == (A .== 0.5)
            @test (M .== A) == B1
        end
    end
end

M = ImageMeta([1,2,3,4])
@test minimum(M) == 1
@test maximum(M) == 4
Mp = M'
@test ndims(Mp) == 2
Ms = dropdims(Mp, dims=1)
@test Ms == M

img = convert(ImageMeta{Gray{N0f16}}, [0.01164 0.01118; 0.01036 0.01187])
@test all((1 .- img) .== (1 .- img))

nothing

@info "Beginning deprecation tests"

@testset "Deprecations" begin
    @testset "copy/similar" begin
        img = ImageMeta(rand(3,5); prop1 = 1, prop2 = [1,2,3])
        img2 = copy(img)
        @test img2.data == img.data
        img2[2,2] = -1
        @test img2[2,2] < 0
        @test img[2,2] >= 0
        img2["prop2"][2] = -2
        @test img2["prop2"] == [1,-2,3]
        @test img["prop2"] == [1,2,3]
        img2 = similar(img)
        @test img2["prop1"] == 1
        @test img2["prop2"] == [1,2,3]
        @test img2.data != img.data
        img2["prop3"] = 7
        @test !haskey(img, "prop3")
        img2 = similar(img, RGB{Float16}, (Base.OneTo(5),))
        @test img2["prop1"] == 1
        @test img2["prop2"] == [1,2,3]
        @test eltype(img2) == RGB{Float16}
        @test size(img2) == (5,)
        @test img2.data != img.data
        img2["prop3"] = 7
        @test !haskey(img, "prop3")

        A = AxisArray(rand(3,5), :y, :x)
        B = ImageMeta(A, info="blah")
        C = similar(B)
        @test isa(C, ImageMeta)
        @test isa(C.data, AxisArray)
        @test eltype(C) == Float64
        C = similar(B, RGB{Float16})
        @test isa(C, ImageMeta)
        @test isa(C.data, AxisArray)
        @test eltype(C) == RGB{Float16}
    end

    @testset "copy/shareproperties/viewim" begin
        img = ImageMeta(rand(3,5); prop1 = 1, prop2 = [1,2,3])
        @test !isempty(properties(img))
        v = view(img, 1:2, 1:2)
        c = img[1:2, 1:2]
        @test v["prop1"] == 1
        @test c["prop1"] == 1
        img2 = copyproperties(img, reshape(1:15, 5, 3))
        @test size(img2) == (5,3)
        img2["prop1"] = -1
        @test img["prop1"] == 1
        img2 = shareproperties(img, reshape(1:15, 5, 3))
        @test size(img2) == (5,3)
        img2["prop1"] = -1
        @test img["prop1"] == -1
        @test v["prop1"] == -1
        @test c["prop1"] == 1
        imgb = ImageMeta(rand(RGB{N0f8}, 2, 2), propa = "hello", propb = [1,2])
        copy!(img, imgb, "propa", "propb")
        @test img["propa"] == "hello"
        @test img["propb"] == [1,2]
        img["propb"][2] = 10
        @test img["propb"] == [1,10]
        @test imgb["propb"] == [1,2]
        delete!(img, "propb")
        @test  haskey(img, "propa")
        @test !haskey(img, "propb")

        img = ImageMeta(AxisArray(rand(3,5,8),
                                  Axis{:x}(1:3),
                                  Axis{:y}(1:5),
                                  Axis{:time}(0.1:0.1:0.8));
                        prop1 = 1, prop2 = [1,2,3])
        v = view(img, Axis{:time}(0.25..0.5))
        c = img[Axis{:time}(0.25..0.5)]
        @test v["prop1"] == 1
        @test c["prop1"] == 1
    end

    @testset "traits" begin
        img = ImageMeta(AxisArray(rand(3,5,8),
                                  Axis{:x}(1:3),
                                  Axis{:y}(1:5),
                                  Axis{:time}(0.1:0.1:0.8)))
        @test @inferred(timedim(img)) == 3
        @test @inferred(pixelspacing(img)) === (1,1)
        @test spacedirections(img) === ((1,0),(0,1))
        img["spacedirections"] = "broken"
        @test spacedirections(img) == "broken"
        @test sdims(img) == 2
        @test @inferred(coords_spatial(img)) == (1,2)
        @test spatialorder(img) == (:x, :y)
        @test nimages(img) == 8
        @test @inferred(size_spatial(img)) == (3,5)
        @test @inferred(indices_spatial(img)) == (Base.OneTo(3), Base.OneTo(5))
        assert_timedim_last(img)
        @test timeaxis(img) == Axis{:time}(0.1:0.1:0.8)
    end

    @testset "spatialprops" begin
        img = ImageMeta(rand(3,5),
                        spatialproperties=Set(["vector","matrix","tuple"]),
                        vector=[1,2],
                        matrix=[1 3; 2 4],
                        tuple=(1,2))
        for imgp in (img', permutedims(img, (2,1)), PermutedDimsArray(img, (2,1)))
            @test imgp.data == img.data'
            @test imgp["vector"] == [2,1]
            @test imgp["matrix"] == [4 2; 3 1]
            @test imgp["tuple"]  == (2,1)
            @test img["vector"] == [1,2]
            @test img["matrix"] == [1 3; 2 4]
            @test img["tuple"]  == (1,2)
        end
    end

    @testset "AbstractDicts" begin
        img = ImageMeta(AxisArray(rand(3,5,8),
                                  Axis{:x}(1:3),
                                  Axis{:y}(1:5),
                                  Axis{:time}(0.1:0.1:0.8)),
                        IdDict{String,Any}("pixelspacing" => (1,1)))
        @test @inferred(pixelspacing(img)) === (1,1)

        rand_img = rand(10,10)
        dict = Dict("attr1" => 3, "attr2" => 4)
        @test ImageMeta(rand_img, dict)[1, 1] == rand_img[1, 1]
    end
end

nothing

using ImageCore, SimpleTraits, ImageAxes, ImageMetadata, OffsetArrays, ImageBase
using Test
import Dates: now
using Unitful: m
import AxisArrays
using AxisArrays: AxisArray, axisnames, (..)

@testset "indexing" begin
    # 1d images
    for A = (rand(3),
             view(rand(6), 1:2:5),
             view(rand(6), [1,2,4]),
             rand(RGB{N0f8}, 3),
             rand(Gray{N0f8}, 3))
        img = ImageMeta(A, prop1=1, prop2=[1,2,3])
        @test eltype(img) == eltype(A)
        @test IndexStyle(img) == IndexStyle(A)
        @test ndims(img) == 1
        @test size(img) == (3,)
        @test arraydata(img) === A
        for i = 1:3
            @test @inferred(img[i]) === A[i]
        end
        for I in eachindex(img)
            @test @inferred(img[I]) === A[I]
        end
        k = 0
        for a in img
            @test a == A[k+=1]
        end
        img[2] = zero(eltype(img))
        @test A[2] == zero(eltype(A))
        img[3] = oneunit(eltype(img))
        @test A[3] == oneunit(eltype(A))
        @test_throws BoundsError img[0]
        @test_throws BoundsError img[4]
        @test img.prop1 == 1
        @test img.prop2 == [1,2,3]
        img.prop1 = -1
        @test img.prop1 == -1
    end
    for A in (rand(3,5),
              view(rand(4,6), 1:3, 1:5),
              view(rand(4,5), [1,2,4], :),
              reshape(1:15, 3, 5),
              rand(RGB{N0f8}, 3, 5),
              rand(Gray{Float32}, 3, 5))
        img = ImageMeta(A, prop1=1, prop2=[1,2,3]) # TODO: add @inferred (see julia #17719)
        @test eltype(img) == eltype(A)
        @test IndexStyle(img) == IndexStyle(A)
        @test ndims(img) == 2
        @test size(img) == (3,5)
        @test arraydata(img) === A
        for j = 1:5, i = 1:3
            @test @inferred(img[i,j]) === A[i,j]
        end
        for k = 1:15
            @test @inferred(img[k]) === A[k]
        end
        for I in eachindex(img)
            @test @inferred(img[I]) === A[I]
        end
        k = 0
        for a in img
            @test a == A[k+=1]
        end
        if !isa(A, typeof(reshape(1:15, 3, 5)))
            img[2,3] = zero(eltype(img))
            @test A[2,3] == zero(eltype(A))
            img[4] = oneunit(eltype(img))
            @test A[4] == oneunit(eltype(A))
        end
        @test_throws BoundsError img[0,0]
        @test_throws BoundsError img[4,1]
        @test_throws BoundsError img[1,6]
        @test img.prop1 == 1
        @test img.prop2 == [1,2,3]
        img.prop1 = -1
        @test img.prop1 == -1
        # vector-indexing
        @test isa(@inferred(img[:,:]), ImageMeta) && img[:,:] == img
        @test isa(@inferred(img[:]), ImageMeta) && img[:] == A[:]
        @test isa(@inferred(img[1:2,1:2]), ImageMeta) && img[1:2,1:2] == A[1:2,1:2]
        @test isa(@inferred(img[1:2,:]), ImageMeta) && img[1:2,:] == A[1:2,:]
        @test isa(@inferred(img[:,1:2]), ImageMeta) && img[:,1:2] == A[:,1:2]
        @test isa(@inferred(view(img,:,:)), ImageMeta) && view(img,:,:) == img
        @test isa(@inferred(view(img,:)), ImageMeta) && view(img,:) == A[:]
        @test isa(@inferred(view(img,1:2,1:2)), ImageMeta) && view(img,1:2,1:2) == A[1:2,1:2]
        @test isa(@inferred(view(img,1:2,:)), ImageMeta) && view(img,1:2,:) == A[1:2,:]
        @test isa(@inferred(view(img,:,1:2)), ImageMeta) && view(img,:,1:2) == A[:,1:2]
    end
    # Test bounds-checking removal by @inbounds
    if Base.JLOptions().check_bounds != 1 && Base.JLOptions().can_inline == 1
        set5!(x) = @inbounds x[5] = 1.234
        get5(x) = @inbounds x[5]
        aa = zeros(3)
        sizehint!(aa, 10)  # make sure we don't cause a segfault
        a = ImageMeta(aa)
        @test_throws BoundsError a[5]
        set5!(a)
        val = get5(a)
        @test val == 1.234
        a = zeros(3,5)
    end

    # Issue #10
    A = AxisArray(rand(3,5), :y, :x)
    B = ImageMeta(A, info="blah")
    Broi = B[2:3, 2:3]
    @test isa(Broi, ImageMeta)
    @test axisnames(Broi) == (:y, :x)
    A1, B1 = A[2:7], B[2:7]
    @test isa(B1, ImageMeta) && A1 == B1
    Broi = view(B, 2:3, 2:3)
    @test isa(Broi, ImageMeta)
    @test axisnames(Broi) == (:y, :x)

    # Non-1 indexing
    Ao = OffsetArray(rand(2,3), 0:1, -1:1)
    A = ImageMeta(Ao, info="blah")
    @test axes(A) === axes(Ao)
end

@testset "convert" begin
    A = rand(3,5)
    M = convert(ImageMeta, A)
    @test isa(M, ImageMeta)
    @test convert(ImageMeta, M) === M
    @test convert(ImageMeta{Float64}, M) === M
    @test eltype(convert(ImageMeta{Gray{Float64}}, M)) == Gray{Float64}
    metagray = Gray.(M)
    @test eltype(metagray) == Gray{Float64} && isa(metagray, ImageMeta)
    @test convert(ImageMeta{Gray{Float64}}, M) == M
    @test convert(ImageMeta{Gray{Float64}}, A) == A
end

@testset "reinterpret" begin
    # It's possible that reinterpretc shouldn't be defined for ImageMeta, but...
    A = rand(Float32, 4, 5)
    M = ImageMeta(A, meta=true)
    Mr = reinterpretc(Gray, M)
    @test eltype(Mr) == Gray{Float32}
    @test Mr.meta = true
    # Ensure that it gets defined for the formerly un-reinterpretable
    A = zeros(Float32, 4, 5)
    M = ImageMeta(view(A, 1:2:3, 1:4), meta=true)
    Mr = reinterpretc(Gray, M)
    Mr = reinterpretc(Gray{Float32}, M)
    @test eltype(Mr) == Gray{Float32}
    @test Mr.meta = true
    Mr[:] .= Gray{Float32}(0.5)
    @test all(A[1:2:3,1:4] .== 0.5)
end

@testset "copy/similar" begin
    img = ImageMeta(rand(3,5); prop1 = 1, prop2 = [1,2,3])
    img2 = copy(img)
    @test arraydata(img2) == arraydata(img)
    img2[2,2] = -1
    @test img2[2,2] < 0
    @test img[2,2] >= 0
    img2.prop2[2] = -2
    @test img2.prop2 == [1,-2,3]
    @test img.prop2 == [1,2,3]
    img2 = similar(img)
    @test img2.prop1 == 1
    @test img2.prop2 == [1,2,3]
    @test arraydata(img2) != arraydata(img)
    img2.prop3 = 7
    @test !hasproperty(img, :prop3)
    img2 = similar(img, RGB{Float16}, (Base.OneTo(5),))
    @test img2.prop1 == 1
    @test img2.prop2 == [1,2,3]
    @test eltype(img2) == RGB{Float16}
    @test size(img2) == (5,)
    @test arraydata(img2) != arraydata(img)
    img2.prop3 = 7
    @test !hasproperty(img, :prop3)

    A = AxisArray(rand(3,5), :y, :x)
    B = ImageMeta(A, info="blah")
    C = similar(B)
    @test isa(C, ImageMeta)
    @test isa(arraydata(C), AxisArray)
    @test eltype(C) == Float64
    C = similar(B, RGB{Float16})
    @test isa(C, ImageMeta)
    @test isa(arraydata(C), AxisArray)
    @test eltype(C) == RGB{Float16}
end

@testset "copy/shareproperties/viewim" begin
    img = ImageMeta(rand(3,5); prop1 = 1, prop2 = [1,2,3])
    @test !isempty(properties(img))
    v = view(img, 1:2, 1:2)
    c = img[1:2, 1:2]
    @test v.prop1 == 1
    @test c.prop1 == 1
    img2 = copyproperties(img, reshape(1:15, 5, 3))
    @test size(img2) == (5,3)
    img2.prop1 = -1
    @test img.prop1 == 1
    img2 = shareproperties(img, reshape(1:15, 5, 3))
    @test size(img2) == (5,3)
    img2.prop1 = -1
    @test img.prop1 == -1
    @test v.prop1 == -1
    @test c.prop1 == 1
    imgb = ImageMeta(rand(RGB{N0f8}, 2, 2), propa = "hello", propb = [1,2])
    copy!(img, imgb, :propa, :propb)
    @test img.propa == "hello"
    @test img.propb == [1,2]
    img.propb[2] = 10
    @test img.propb == [1,10]
    @test imgb.propb == [1,2]
    delete!(img, :propb)
    @test  hasproperty(img, :propa)
    @test !hasproperty(img, :propb)

    img = ImageMeta(AxisArray(rand(3,5,8),
                              Axis{:x}(1:3),
                              Axis{:y}(1:5),
                              Axis{:time}(0.1:0.1:0.8));
                    prop1 = 1, prop2 = [1,2,3])
    v = view(img, Axis{:time}(0.25..0.5))
    c = img[Axis{:time}(0.25..0.5)]
    @test v.prop1 == 1
    @test c.prop1 == 1
end

@testset "views" begin
    for A1 in (rand(Gray{N0f8}, 4, 5), rand(RGB{Float32}, 4, 5))
        t1 = now()
        M1 = ImageMeta(A1, date=t1)
        vM1 = channelview(M1)
        @test isa(vM1, ImageMeta)
        @test vM1.date == t1
        @test arraydata(vM1) == channelview(A1)
        @test isa(rawview(vM1), ImageMeta)
        if ndims(rawview(vM1)) == 3
            @test rawview(vM1)[1,2,1] === rawview(channelview(A1))[1,2,1]
        else
            @test rawview(vM1)[1,2] === rawview(channelview(A1))[1,2]
        end
    end
    for (A1,C) in ((rand(UInt8, 4, 5), Gray), (rand(UInt8, 3, 4, 5), RGB))
        M1 = ImageMeta(A1)
        vM1 = normedview(M1)
        @test isa(vM1, ImageMeta)
        @test arraydata(vM1) == normedview(A1)
        cvM = colorview(C, vM1)
        @test isa(cvM, ImageMeta)
        @test cvM[1,2] === colorview(C, normedview(A1))[1,2]
    end
    A = AxisArray(rand(RGB{N0f8}, 3, 5), :y, :x)
    t = now()
    M = ImageMeta(A, date=t)
    vM = channelview(M)
    @test isa(vM, ImageMeta)
    @test colordim(vM) == 1
    pvM = permutedims(vM, (2,3,1))
    @test colordim(pvM) == 3
    @test pvM.date == t
    sleep(0.1)
    pvM.date = now()
    @test M.date == t && pvM.date != t
    vM = PermutedDimsArray(M, (2,1))
    @test vM.date == t
    @test axisnames(vM) == (:x, :y)
end

@testset "meta-axes" begin
    A = AxisArray(rand(3,5), :y, :x)
    M = ImageMeta(A)
    @test AxisArrays.HasAxes(M) == AxisArrays.HasAxes{true}()
    @test AxisArrays.axes(M) == (Axis{:y}(1:3), Axis{:x}(1:5))
    @test AxisArrays.axes(M, 2) == Axis{:x}(1:5)
    @test AxisArrays.axes(M, Axis{:y}) == Axis{:y}(1:3)
    @test AxisArrays.axes(M, Axis{:x}()) == Axis{:x}(1:5)
    @test axisdim(M, Axis{:y}) == 1
    @test size(M, Axis{:y}) == 3
    @test size(M, Axis{:x}()) == 5
    @test axes(M, Axis{:y}) === Base.OneTo(3)
    @test axes(M, Axis{:x}()) == Base.OneTo(5)
    @test axisdim(M, Axis{:x}) == 2
    @test_throws ErrorException axisdim(M, Axis{:z})
    @test axisnames(M) == (:y, :x)
    @test axisvalues(M) == (1:3, 1:5)
    @test M[Axis{:y}(2:3)] == A[Axis{:y}(2:3)]
    @test view(M, Axis{:y}(2:3)) == A[Axis{:y}(2:3)]
    M[Axis{:y}(2:3), Axis{:x}(1)] .= -5
    @test all(A[2:3,1] .== -5)
end

@testset "show" begin
    for supp in (Set([:prop3]), :prop3)
        img = ImageMeta(rand(3,5); prop1 = 1, prop2 = [1,2,3], suppress = supp, prop3 = "hide")
        str = string(img)
        @test occursin("ImageMeta with", str)
        @test occursin("prop1", str)
        @test occursin("prop2", str)
        @test occursin("$([1,2,3])", str)
        @test occursin("prop3", str)
        @test !occursin("hide", str)
        @test occursin("<suppressed>", str)
        @test !occursin("suppress:", str)
        io = IOBuffer()
        show(io, MIME("text/plain"), img)
        str2 = String(take!(io))
        @test str == str2
    end
end

@testset "traits" begin
    img = ImageMeta(AxisArray(rand(3,5,8),
                              Axis{:x}(1:3),
                              Axis{:y}(1:5),
                              Axis{:time}(0.1:0.1:0.8)))
    @test @inferred(timedim(img)) == 3
    @test @inferred(pixelspacing(img)) === (1,1)
    @test spacedirections(img) === ((1,0),(0,1))
    img.spacedirections = "broken"
    @test spacedirections(img) == "broken"
    @test sdims(img) == 2
    @test @inferred(coords_spatial(img)) == (1,2)
    @test spatialorder(img) == (:x, :y)
    @test nimages(img) == 8
    @test @inferred(size_spatial(img)) == (3,5)
    @test @inferred(indices_spatial(img)) == (Base.OneTo(3), Base.OneTo(5))
    assert_timedim_last(img)
    @test timeaxis(img) == Axis{:time}(0.1:0.1:0.8)
end

@testset "spatialprops" begin
    img = ImageMeta(rand(3,5),
                    spatialproperties=Set([:vector,:matrix,:tuple]),
                    vector=[1,2],
                    matrix=[1 3; 2 4],
                    tuple=(1,2))
    for imgp in (img', permutedims(img, (2,1)), PermutedDimsArray(img, (2,1)))
        @test arraydata(imgp) == arraydata(img)'
        @test imgp.vector == [2,1]
        @test imgp.matrix == [4 2; 3 1]
        @test imgp.tuple  == (2,1)
        @test img.vector == [1,2]
        @test img.matrix == [1 3; 2 4]
        @test img.tuple  == (1,2)
    end
end

@testset "dimchange" begin
    M = ImageMeta([1,2,3,4])
    Mp = M'
    @test ndims(Mp) == 2 && isa(Mp, ImageMeta)

    M = ImageMeta([1,2,3,4],
                  spatialproperties=[:vector],
                  vector=[1])
    @test_throws ErrorException M'
end

@testset "Inference" begin
    # Heavily-nested types tax Julia's inference capabilities
    a = rand(N2f14, 3, 5, 2)
    a1 = a[1,1,1]
    aa = AxisArray(a, Axis{:y}(0:2), Axis{:x}(0:4), Axis{:z}(0:1))
    cv = colorview(RGB, aa, zeroarray, aa)
    @test @inferred(cv[1,1,1]) == RGB(a1, zero(a1), a1)
    au = AxisArray(a, Axis{:y}(0m:1m:2m), Axis{:x}(0m:1m:4m), Axis{:z}(0m:1m:1m))
    cv = colorview(RGB, au, zeroarray, au)
    @test @inferred(cv[1,1,1]) == RGB(a1, zero(a1), a1)
    am = ImageMeta(au)
    cv = colorview(RGB, am, zeroarray, am)
    @inferred cv[1,1,1]
end

@testset "AxisArray_CartesianIndex" begin
    M = reshape([1,2,3,4], 2,2)
    M = AxisArray(M)
    img = ImageMeta(M)
    @test 1 == img[1, CartesianIndex(1)] #Int and cartesianindex
    @test maximum(img,dims=2) == reshape([3,4],2,1)
    @test mean(img,dims=1) == reshape([1.5,3.5], 1,2)
end

@testset "AbstractDicts" begin
    img = ImageMeta(AxisArray(rand(3,5,8),
                              Axis{:x}(1:3),
                              Axis{:y}(1:5),
                              Axis{:time}(0.1:0.1:0.8)),
                    IdDict{Symbol,Any}(:pixelspacing => (1,1)))
    @test @inferred(pixelspacing(img)) === (1,1)

    rand_img = rand(10,10)
    dict = Dict(:attr1 => 3, :attr2 => 4)
    @test ImageMeta(rand_img, dict)[1, 1] == rand_img[1, 1]
end

@testset "OffsetArrays" begin
    if isdefined(OffsetArrays, :centered)
        # OffsetArrays v1.9+ only
        @testset "centered" begin
            check_range(r, f, l) = (@test first(r) == f; @test last(r) == l)
            check_range_axes(r, f, l) = check_range(axes(r)[1], f, l)

            check_range(Base.axes(OffsetArrays.centered(1:3))[1], -1, 1)
            a = AxisArray(rand(3, 3), Axis{:y}(0.1:0.1:0.3), Axis{:x}(1:3))
            am = ImageMeta(a; prop1="simple")
            ca = OffsetArrays.centered(am)
            axs = Base.axes(ca)
            check_range(axs[1], -1, 1)
            check_range(axs[2], -1, 1)
            @test Base.axes(arraydata(ca)) == axs
        end
    end
end

@testset "restrict" begin
    imgcol = rand(RGB{Float32}, 5, 6)

    for dims in [(), (1, ), (1, 2)]
        imgmeta = ImageMeta(imgcol, myprop=1)

        out = restrict(imgmeta, dims)
        @test out isa ImageMeta
        @test out.myprop == 1
        @test arraydata(out) == restrict(arraydata(imgmeta), dims)
    end

    imgcolax = AxisArray(imgcol, :y, :x)
    for ax in [Axis{:x}, Axis{:y}]
        imgmetaax = ImageMeta(imgcolax, myprop=1)
        out = restrict(imgmetaax, ax)
        @test out isa ImageMeta
        @test out.myprop == 1
        @test arraydata(out) == restrict(arraydata(imgmetaax), ax)
    end
end

nothing

using ImageCore: AbstractGray, TransparentGray, TransparentRGB

# Specialize the low-level broadcasting machinery for ImageMeta.
# This make it work for all operators, rather than specializing
# each operator individually.
Base.BroadcastStyle(::Type{<:ImageMeta}) = Broadcast.ArrayStyle{ImageMeta}()
function Base.similar(bc::Broadcast.Broadcasted{Broadcast.ArrayStyle{ImageMeta}}, ::Type{ElType}) where ElType
    Mt = imagemeta(bc.args...)
    if length(Mt) > 0
        M = Mt[1]
        if length(Mt) > 1
            for i = 2:length(Mt)
                Mt[i] == M || return ambigop(:Broadcast)
            end
        end
        # Use the properties field of img to create the output
        ret = ImageMeta(similar(Array{ElType}, axes(bc)), properties(M))
    else
        ret = ImageMeta(similar(Array{ElType}, axes(bc)))
    end
    ret
end
# Select all the ImageMeta arrays
@inline imagemeta(As...) = _imagemeta((), As...)
_imagemeta(out) = out
@inline _imagemeta(out, A::ImageMeta, As...) = _imagemeta((out..., A), As...)
@inline _imagemeta(out, A, As...) = _imagemeta(out, As...)


(-)(img::ImageMeta) = shareproperties(img, -arraydata(img))

batch2 = (:+, :-)

for op in batch2
    @eval begin
        ($op)(img::ImageMeta, B::BitArray) = shareproperties(img, ($op)(arraydata(img), B))
        ($op)(B::BitArray, img::ImageMeta) = shareproperties(img, ($op)(B, arraydata(img)))
        ($op)(img::ImageMeta, B::ImageMeta) = ambigop(Symbol($op))
        ($op)(img::ImageMeta, B::AbstractArray) = shareproperties(img, ($op)(arraydata(img), B))
        ($op)(B::AbstractArray, img::ImageMeta) = shareproperties(img, ($op)(B, arraydata(img)))
    end

    for CV in (:AbstractGray, :TransparentGray, :AbstractRGB, :TransparentRGB)
        @eval begin
            ($op)(img::ImageMeta{CV}, n::$CV) where {CV<:$CV} =
                shareproperties(img, ($op)(arraydata(img), n))
            ($op)(n::$CV, img::ImageMeta{CV}) where {CV<:$CV} =
                shareproperties(img, ($op)(n, arraydata(img)))
        end
    end
end

(/)(img::ImageMeta, n::Number) = shareproperties(img, arraydata(img)/n)

ambigop(s::Symbol) = error("$s with two ImageMeta arrays: dictionary choice is ambiguous")

module ImageMetadata

# The order here is designed to avoid an ambiguity warning in convert,
# see the top of ImageAxes
using ImageAxes
using ImageCore
using ImageCore.OffsetArrays
using ImageBase
import AxisArrays

import Base: +, -, *, /
import Base: permutedims


const ViewIndex = Union{Base.ViewIndex, Colon}

export
    # types
    ImageMeta,

    # functions
    copyproperties,
    arraydata,
    properties,
    shareproperties,
    spatialproperties

#### types and constructors ####

# Concrete types
"""
`ImageMeta` is an AbstractArray that can have metadata, stored in a dictionary.

Construct an image with `ImageMeta(A, props)` (for a properties dictionary
`props`), or with `ImageMeta(A, prop1=val1, prop2=val2, ...)`.
"""
struct ImageMeta{T,N,A<:AbstractArray,P<:AbstractDict{Symbol,Any}} <: AbstractArray{T,N}
    data::A
    properties::P
end

function ImageMeta(data::AbstractArray{T,N}, props::AbstractDict{Symbol,Any}) where {T,N}
    return ImageMeta{T,N,typeof(data),typeof(props)}(data,props)
end
function ImageMeta(data::AbstractArray{T,N}, props::Dict{Symbol,Any}) where {T,N}
    return ImageMeta{T,N,typeof(data),typeof(props)}(data,props)
end
function ImageMeta(data::AbstractArray, props::Dict{Symbol})
    return ImageMeta(data, convert(Dict{Symbol,Any}, props))
end
function ImageMeta(data::AbstractArray; kwargs...)
    return ImageMeta(data, kwargs2dict(kwargs))
end
ImageMeta(data::AbstractArray, props::AbstractDict) = throw(ArgumentError("properties must be an AbstractDict{Symbol,Any}"))

const ImageMetaArray{T,N,A<:Array} = ImageMeta{T,N,A}
const ImageMetaAxis{T,N,A<:AxisArray} = ImageMeta{T,N,A}

Base.size(A::ImageMeta) = size(arraydata(A))
Base.size(A::ImageMetaAxis, Ax::Axis) = size(arraydata(A), Ax)
Base.size(A::ImageMetaAxis, ::Type{Ax}) where {Ax<:Axis} = size(arraydata(A), Ax)
Base.axes(A::ImageMeta) = axes(arraydata(A))
Base.axes(A::ImageMetaAxis, Ax::Axis) = axes(arraydata(A), Ax)
Base.axes(A::ImageMetaAxis, ::Type{Ax}) where {Ax<:Axis} = axes(arraydata(A), Ax)

datatype(::Type{ImageMeta{T,N,A,P}}) where {T,N,A<:AbstractArray,P} = A

Base.IndexStyle(::Type{M}) where {M<:ImageMeta} = IndexStyle(datatype(M))

AxisArrays.HasAxes(A::ImageMetaAxis) = AxisArrays.HasAxes{true}()

# getindex and setindex!
for AType in (ImageMeta, ImageMetaAxis)
    @eval begin
        @inline function Base.getindex(img::$AType{T,1}, i::Int) where T
            @boundscheck checkbounds(arraydata(img), i)
            @inbounds ret = arraydata(img)[i]
            ret
        end
        @inline function Base.getindex(img::$AType, i::Int)
            @boundscheck checkbounds(arraydata(img), i)
            @inbounds ret = arraydata(img)[i]
            ret
        end
        @inline function Base.getindex(img::$AType{T,N}, I::Vararg{Int,N}) where {T,N}
            @boundscheck checkbounds(arraydata(img), I...)
            @inbounds ret = arraydata(img)[I...]
            ret
        end

        @inline function Base.setindex!(img::$AType{T,1}, val, i::Int) where T
            @boundscheck checkbounds(arraydata(img), i)
            @inbounds arraydata(img)[i] = val
            val
        end
        @inline function Base.setindex!(img::$AType, val, i::Int)
            @boundscheck checkbounds(arraydata(img), i)
            @inbounds arraydata(img)[i] = val
            val
        end
        @inline function Base.setindex!(img::$AType{T,N}, val, I::Vararg{Int,N}) where {T,N}
            @boundscheck checkbounds(arraydata(img), I...)
            @inbounds arraydata(img)[I...] = val
            val
        end
    end
end

@inline function Base.getindex(img::ImageMetaAxis, ax::Axis, I...)
    result = arraydata(img)[ax, I...]
    maybe_wrap(img, result)
end
@inline function Base.getindex(img::ImageMetaAxis, i::Union{Integer,AbstractVector,Colon}, I...)
    result = arraydata(img)[i, I...]
    maybe_wrap(img, result)
end
maybe_wrap(img::ImageMeta{T}, result::T) where T = result
maybe_wrap(img::ImageMeta{T}, result::AbstractArray{T}) where T = copyproperties(img, result)


@inline function Base.setindex!(img::ImageMetaAxis, val, ax::Axis, I...)
    setindex!(arraydata(img), val, ax, I...)
end
@inline function Base.setindex!(img::ImageMetaAxis, val, i::Union{Integer,AbstractVector,Colon}, I...)
    setindex!(arraydata(img), val, i, I...)
end

Base.view(img::ImageMeta, ax::Axis, I...) = shareproperties(img, view(arraydata(img), ax, I...))
Base.view(img::ImageMeta{T,N}, I::Vararg{ViewIndex,N}) where {T,N} = shareproperties(img, view(arraydata(img), I...))
Base.view(img::ImageMeta, i::ViewIndex) = shareproperties(img, view(arraydata(img), i))
Base.view(img::ImageMeta, I::Vararg{ViewIndex,N}) where {N} = shareproperties(img, view(arraydata(img), I...))

function Base.getproperty(img::ImageMeta, propname::Symbol)
    # TODO remove these once deprecations are done
    if propname === :data
        Base.depwarn("img.data is deprecated use arraydata(img) to extract data img.", :arraydata)
        return arraydata(img)
    elseif propname === :properties
        Base.depwarn("img.properties is deprecated use properties(img) to extract data img.", :properties)
        return properties(img)
    else
        return properties(img)[propname]
    end
end

function Base.setproperty!(img::ImageMeta, propname::Symbol, val)
    # TODO remove these once deprecations are done
    if propname === :data
        Base.depwarn("Replacing the data field with is deprecated. Consider creating a new instance of ImageMeta instead.", :rawdata)
        setindex!(img, val, img)
    elseif propname === :properties
        Base.depwarn("Replacing the properties field is deprecated. Consider creating a new instance of ImageMeta instead.", :properties)
        for (k,v) in val
            setproperty!(img, k, v)
        end
    else
        properties(img)[propname] = val
    end
    return img
end

Base.propertynames(img::ImageMeta) = (keys(properties(img))...,)

Base.copy(img::ImageMeta) = ImageMeta(copy(arraydata(img)), deepcopy(properties(img)))

Base.convert(::Type{ImageMeta}, A::ImageMeta) = A
Base.convert(::Type{ImageMeta}, A::AbstractArray) = ImageMeta(A)
Base.convert(::Type{ImageMeta{T}}, A::ImageMeta{T}) where {T} = A
Base.convert(::Type{ImageMeta{T}}, A::ImageMeta) where {T} = shareproperties(A, convert(AbstractArray{T}, arraydata(A)))
Base.convert(::Type{ImageMeta{T}}, A::AbstractArray{T}) where {T} = ImageMeta(A)
Base.convert(::Type{ImageMeta{T}}, A::AbstractArray) where {T} = ImageMeta(convert(AbstractArray{T}, A))

# copy properties
function Base.copy!(imgdest::ImageMeta, imgsrc::ImageMeta, prop1::Symbol, props::Symbol...)
    setproperty!(imgdest, prop1, deepcopy(getproperty(imgsrc, prop1)))
    for p in props
        setproperty!(imgdest, p, deepcopy(getproperty(imgsrc, p)))
    end
    return imgdest
end

# similar
Base.similar(img::ImageMeta, ::Type{T}, shape::Dims) where {T} = ImageMeta(similar(arraydata(img), T, shape), copy(properties(img)))
Base.similar(img::ImageMetaAxis, ::Type{T}) where {T} = ImageMeta(similar(arraydata(img), T), copy(properties(img)))

"""
    copyproperties(img::ImageMeta, data) -> imgnew

Create a new "image," copying the properties dictionary of `img` but
using the data of the AbstractArray `data`. Note that changing the
properties of `imgnew` does not affect the properties of `img`.

See also: [`shareproperties`](@ref).
"""
copyproperties(img::ImageMeta, data::AbstractArray) =
    ImageMeta(data, copy(properties(img)))

"""
    shareproperties(img::ImageMeta, data) -> imgnew

Create a new "image," reusing the properties dictionary of `img` but
using the data of the AbstractArray `data`. The two images have
synchronized properties; modifying one also affects the other.

See also: [`copyproperties`](@ref).
"""
shareproperties(img::ImageMeta, data::AbstractArray) = ImageMeta(data, properties(img))

# Delete a property!
Base.delete!(img::ImageMeta, propname::Symbol) = delete!(properties(img), propname)


# Iteration
# Defer to the array object in case it has special iteration defined
Base.iterate(img::ImageMeta) = Base.iterate(arraydata(img))
Base.iterate(img::ImageMeta, s) = Base.iterate(arraydata(img), s)

# Show
const emptyset = Set()
function showim(io::IO, img::ImageMeta)
    IT = typeof(img)
    print(io, eltype(img).name.name, " ImageMeta with:\n  data: ", summary(arraydata(img)), "\n  properties:")
    showdictlines(io, properties(img), get(img, :suppress, emptyset))
end
Base.show(io::IO, img::ImageMeta) = showim(io, img)
Base.show(io::IO, ::MIME"text/plain", img::ImageMeta) = showim(io, img)

function Base.reinterpret(::Type{T}, img::ImageMeta) where {T}
    shareproperties(img, reinterpret(T, arraydata(img)))
end
if Base.VERSION >= v"1.6.0-DEV.1083"
    function Base.reinterpret(::typeof(reshape), ::Type{T}, img::ImageMeta) where {T}
        shareproperties(img, reinterpret(reshape, T, arraydata(img)))
    end
end


"""
    arraydata(img::ImageMeta) -> array

Extract the data from `img`, omitting the properties
dictionary. `array` shares storage with `img`, so changes to one
affect the other.

See also: [`properties`](@ref).
"""
ImageAxes.arraydata(img::ImageMeta) = getfield(img, :data)

function Base.PermutedDimsArray(A::ImageMeta, perm)
    ip = sortperm([perm...][[coords_spatial(A)...]])  # the inverse spatial permutation
    permutedims_props!(copyproperties(A, PermutedDimsArray(arraydata(A), perm)), ip)
end
ImageCore.channelview(A::ImageMeta) = shareproperties(A, channelview(arraydata(A)))
ImageCore.colorview(::Type{C}, A::ImageMeta{T,N}) where {C<:Colorant,T,N} = shareproperties(A, colorview(C, arraydata(A)))
ImageCore.colorview(::Type{ARGB32}, A::ImageMeta{T,N}) where {T,N} = shareproperties(A, colorview(ARGB32, arraydata(A)))
ImageCore.rawview(A::ImageMeta{T}) where {T<:Real} = shareproperties(A, rawview(arraydata(A)))
ImageCore.normedview(::Type{T}, A::ImageMeta{S}) where {T<:FixedPoint,S<:Unsigned} = shareproperties(A, normedview(T, arraydata(A)))

# AxisArrays functions
AxisArrays.axes(img::ImageMetaAxis) = AxisArrays.axes(arraydata(img))
AxisArrays.axes(img::ImageMetaAxis, d::Int) = AxisArrays.axes(arraydata(img), d)
AxisArrays.axes(img::ImageMetaAxis, Ax::Axis) = AxisArrays.axes(arraydata(img), Ax)
AxisArrays.axes(img::ImageMetaAxis, ::Type{Ax}) where {Ax<:Axis} = AxisArrays.axes(arraydata(img), Ax)
AxisArrays.axisdim(img::ImageMetaAxis, ax) = axisdim(arraydata(img), ax)
AxisArrays.axisnames(img::ImageMetaAxis) = axisnames(arraydata(img))
AxisArrays.axisvalues(img::ImageMetaAxis) = axisvalues(arraydata(img))

# OffsetArrays functions
if isdefined(OffsetArrays, :centered)
    # Compat for OffsetArrays v1.9
    # https://github.com/JuliaArrays/OffsetArrays.jl/pull/242
    OffsetArrays.centered(a::ImageMeta) = ImageMeta(OffsetArrays.centered(arraydata(a)), properties(a))
end

ImageBase.restrict(img::ImageMeta, ::Tuple{}) = img
ImageBase.restrict(img::ImageMeta, region::Dims) = shareproperties(img, restrict(arraydata(img), region))
function ImageBase.restrict(img::ImageMetaAxis, ::Type{Ax}) where Ax
    shareproperties(img, restrict(arraydata(img), Ax))
end

#### Properties ####

"""
    properties(imgmeta) -> props

Extract the properties dictionary `props` for `imgmeta`. `props`
shares storage with `img`, so changes to one affect the other.

See also: [`arraydata`](@ref).
"""
properties(img::ImageMeta) = getfield(img, :properties)


if isdefined(Base, :hasproperty) # or VERSION >= v"1.2"
    import Base: hasproperty
end
hasproperty(img::ImageMeta, k::Symbol) = haskey(properties(img), k)

Base.get(img::ImageMeta, k::Symbol, default) = get(properties(img), k, default)

# So that defaults don't have to be evaluated unless they are needed,
# we also define a @get macro (thanks Toivo Hennington):
struct IMNothing end   # to avoid confusion in the case where dict[key] === nothing
macro get(img, k, default)
    quote
        img, k = $(esc(img)), $(esc(k))
        val = get(properties(img), k, IMNothing())
        return isa(val, IMNothing) ? $(esc(default)) : val
    end
end

ImageAxes.timeaxis(img::ImageMetaAxis) = timeaxis(arraydata(img))
ImageAxes.timedim(img::ImageMetaAxis) = timedim(arraydata(img))
ImageAxes.colordim(img::ImageMetaAxis) = colordim(arraydata(img))

ImageCore.pixelspacing(img::ImageMeta) = pixelspacing(arraydata(img))

"""
    spacedirections(img)

Using ImageMetadata, you can set this property manually. For example, you
could indicate that a photograph was taken with the camera tilted
30-degree relative to vertical using

```
img["spacedirections"] = ((0.866025,-0.5),(0.5,0.866025))
```

If not specified, it will be computed from `pixelspacing(img)`, placing the
spacing along the "diagonal".  If desired, you can set this property in terms of
physical units, and each axis can have distinct units.
"""
ImageCore.spacedirections(img::ImageMeta) = @get img :spacedirections spacedirections(arraydata(img))

ImageCore.sdims(img::ImageMetaAxis) = sdims(arraydata(img))

ImageCore.coords_spatial(img::ImageMetaAxis) = coords_spatial(arraydata(img))

ImageCore.spatialorder(img::ImageMetaAxis) = spatialorder(arraydata(img))

ImageAxes.nimages(img::ImageMetaAxis) = nimages(arraydata(img))

ImageCore.size_spatial(img::ImageMetaAxis) = size_spatial(arraydata(img))

ImageCore.indices_spatial(img::ImageMetaAxis) = indices_spatial(arraydata(img))

ImageCore.assert_timedim_last(img::ImageMetaAxis) = assert_timedim_last(arraydata(img))

#### Permutations over dimensions ####

"""
    permutedims(img, perm, [spatialprops])

When permuting the dimensions of an ImageMeta, you can optionally
specify that certain properties are spatial and they will also be
permuted. `spatialprops` defaults to `spatialproperties(img)`.
"""
permutedims

function permutedims_props!(ret::ImageMeta, ip, spatialprops=spatialproperties(ret))
    if !isempty(spatialprops)
        for prop in spatialprops
            if hasproperty(ret, prop)
                a = getproperty(ret, prop)
                if isa(a, AbstractVector)
                    setproperty!(ret, prop, a[ip])
                elseif isa(a, Tuple)
                    setproperty!(ret, prop, a[ip])
                elseif isa(a, AbstractMatrix) && size(a,1) == size(a,2)
                    setproperty!(ret, prop, a[ip,ip])
                else
                    error("Do not know how to handle property ", prop)
                end
            end
        end
    end
    ret
end

function permutedims(img::ImageMetaAxis, perm)
    p = AxisArrays.permutation(perm, axisnames(arraydata(img)))
    ip = sortperm([p...][[coords_spatial(img)...]])
    permutedims_props!(copyproperties(img, permutedims(arraydata(img), p)), ip)
end
function permutedims(img::ImageMeta, perm)
    ip = sortperm([perm...][[coords_spatial(img)...]])
    permutedims_props!(copyproperties(img, permutedims(arraydata(img), perm)), ip)
end

# Note: `adjoint` does not recurse into ImageMeta properties.
function Base.adjoint(img::ImageMeta{T,2}) where {T<:Real}
    ip = sortperm([2,1][[coords_spatial(img)...]])
    permutedims_props!(copyproperties(img, adjoint(arraydata(img))), ip)
end

function Base.adjoint(img::ImageMeta{T,1}) where T<:Real
    check_empty_spatialproperties(img)
    copyproperties(img, arraydata(img)')
end

"""
    spatialproperties(img)

Return a vector of strings, containing the names of properties that
have been declared "spatial" and hence should be permuted when calling
`permutedims`.  Declare such properties like this:

    img[:spatialproperties] = [:spacedirections]
"""
spatialproperties(img::ImageMeta) = @get img :spatialproperties [:spacedirections]

function check_empty_spatialproperties(img)
    sp = spatialproperties(img)
    for prop in sp
        if hasproperty(img, prop)
            error("spatialproperties must be empty, have $prop")
        end
    end
    nothing
end

#### Low-level utilities ####
function showdictlines(io::IO, dict::AbstractDict, suppress::Set)
    for (k, v) in dict
        if k === :suppress
            continue
        end
        if !in(k, suppress)
            print(io, "\n    ", k, ": ")
            print(IOContext(io, :compact => true), v)
        else
            print(io, "\n    ", k, ": <suppressed>")
        end
    end
end
showdictlines(io::IO, dict::AbstractDict, prop::Symbol) = showdictlines(io, dict, Set([prop]))

# printdictval(io::IO, v) = print(io, v)
# function printdictval(io::IO, v::Vector)
#     for i = 1:length(v)
#         print(io, " ", v[i])
#     end
# end

# converts keyword argument to a dictionary
function kwargs2dict(kwargs)
    d = Dict{Symbol,Any}()
    for (k, v) in kwargs
        d[k] = v
    end
    return d
end


include("operators.jl")
include("deprecations.jl")

end # module

using ImageCore, ImageAxes, IndirectArrays
using Test, Statistics

mods0 = (Statistics, ImageCore, ImageAxes, IndirectArrays, Base, Core)
ambs0 = detect_ambiguities(mods0...)

using ImageMetadata
ambs = setdiff(detect_ambiguities(ImageMetadata, mods0...), ambs0)
if !isempty(ambs)
    println("Ambiguities:")
    for a in ambs
        println(a)
    end
end
#@test isempty(ambs)

include("core.jl")
include("operations.jl")
include("deprecations.jl")
